# AUTOGENERATED! DO NOT EDIT! File to edit: ../../nbs/missions/2018_psp.ipynb.

# %% auto 0
__all__ = ['fields', 'spc', 'spi', 'psp', 'MagDataVars', 'SPIDataVars', 'validate']

# %% ../../nbs/missions/2018_psp.ipynb 1
from typing import Literal
from ..core import Instrument, Mission

# %% ../../nbs/missions/2018_psp.ipynb 2
fields = Instrument(name="FIELDS")
spc = Instrument(name="SPC")
spi = Instrument(name="SPI")

psp = Mission(
    name="Parker Solar Probe", instruments=[fields, spc, spi], names_list=["psp"]
)

MagDataVars = Literal["psp_fld_l2_mag_RTN",]

SPIDataVars = Literal[
    "QUALITY_FLAG",
    "DENS",
    "VEL_INST",
    "VEL_SC",
    "VEL_RTN_SUN",
    "T_TENSOR_INST",
    "TEMP",  # Temperature (eV)
    "EFLUX_VS_ENERGY",
    "EFLUX_VS_THETA",
    "EFLUX_VS_PHI",
    "SUN_DIST",
    "VENUS_DIST",
    "SC_VEL_RTN_SUN",
    "QUAT_SC_TO_RTN",
    "MAGF_SC",  # Magnetic Field in Spacecraft Coordinates
    "MAGF_INST",
]

# %% ../../nbs/missions/2018_psp.ipynb 3
def validate(instrument, datatype=None, var_names=None, **kwargs):
    "validate the input arguments and return the correct ones"
    if instrument == "fields":
        datatype = datatype or "mag_rtn"
        var_names = var_names or ["psp_fld_l2_mag_RTN"]
    elif instrument == "spi":
        datatype = datatype or "sf00_l3_mom"
        var_names = var_names or ["DENS", "VEL_RTN_SUN", "TEMP"]
    return var_names, datatype
