# AUTOGENERATED! DO NOT EDIT! File to edit: ../../../nbs/missions/wind/index.ipynb.

# %% auto 0
__all__ = ['wi_mfi_h2_ds', 'wi_mfi_h4_rtn_ds', 'wi_pm_3dp_ds', 'wi_k0_swe', 'wi_plsp_3dp_ds', 'wi_elm2_3dp_ds', 'wind_meta']

# %% ../../../nbs/missions/wind/index.ipynb 1
from ...core import Dataset
from ...meta import MissionMeta, MagDataset, TempDataset, PlasmaDataset
from datetime import timedelta

# %% ../../../nbs/missions/wind/index.ipynb 3
wi_mfi_h2_ds = MagDataset(
    name="WI_H2_MFI",
    parameters=["BGSE"],
    ts=timedelta(seconds=1 / 11),
)

wi_mfi_h4_rtn_ds = MagDataset(dataset="WI_H4-RTN_MFI", parameters=["BRTN"])

wi_pm_3dp_ds = PlasmaDataset(
    dataset="WI_PM_3DP",
    parameters=["P_DENS", "P_VELS", "P_TEMP"],  # Proton velocity vector (GSE)
    description="Wind 3dp, PESA LOW 1 spin resolution ion (proton and alpha) moments (computed on spacecraft)",
)

wi_k0_swe = PlasmaDataset(
    dataset="WI_K0_SWE", parameters=["Np", "V_GSE", "THERMAL_SPD"]
)

wi_plsp_3dp_ds = TempDataset(
    dataset="WI_PLSP_3DP",
    parameters=["MOM.P.MAGT3"],  # T_perp = (MAGT3[0] + MAGT3[1])/2
    para_col="proton_MagT3_Z",
    perp_cols=["proton_MagT3_X", "proton_MagT3_Y"],
)

wi_elm2_3dp_ds = TempDataset(
    dataset="WI_ELM2_3DP",
    parameters=["MAGT3"],
    para_col="electron_MagT3_Para",
    perp_cols=["electron_MagT3_Perp1", "electron_MagT3_Perp2"],
)

# %% ../../../nbs/missions/wind/index.ipynb 4
def wind_meta(
    name="Wind",
    mag_ds: MagDataset = wi_mfi_h2_ds,
    plasma_ds: Dataset = wi_pm_3dp_ds,
    ion_temp_ds: TempDataset = wi_plsp_3dp_ds,
    e_temp_ds: TempDataset = wi_elm2_3dp_ds,
    class_factory=MissionMeta,
):
    return class_factory(
        name=name,
        mag_ds=mag_ds,
        plasma_ds=plasma_ds,
        ion_temp_ds=ion_temp_ds,
        e_temp_ds=e_temp_ds,
    )
