# AUTOGENERATED! DO NOT EDIT! File to edit: ../../nbs/utils/20_pds.ipynb.

# %% auto 0
__all__ = ['PDS_URL', 'pds_download']

# %% ../../nbs/utils/20_pds.ipynb 1
import pooch
from pooch import Unzip

# %% ../../nbs/utils/20_pds.ipynb 4
PDS_URL = "https://pds-ppi.igpp.ucla.edu/ditdos/download?id=pds://PPI"

# %% ../../nbs/utils/20_pds.ipynb 5
def pds_download(
    mission,  # planetary missions
    instrument,
    dataset,  # Dataset may correspond to a phase of the mission
    coord,
    datatype,
    path,
    phase_url,
    sat=None,  # satellite name, for missions with multiple satellites
    pds_url=PDS_URL,
) -> list[str]:
    "Downloading file from PDS server"
    # phase_url = PARAMS[mission][instrument][dataset]["url_format"]
    url = f"{pds_url}/{phase_url}/{coord}/{datatype}"

    files = pooch.retrieve(
        url=url,
        known_hash=None,
        path=path,
        processor=Unzip(
            extract_dir=f"{mission}/{instrument}/{dataset}/{coord}/{datatype}"
        ),
    )

    return files
